const ST_CHECK       = 0;
const ST_PRE         = 100;
const ST_PRE_RES     = 101;
const ST_LOGIN       = 200;
const ST_LOGIN_RES   = 201;
const ST_DATA        = 300;
const ST_DATA_RES    = 301;

const LOGIN_URL      = 0;
const LOGIN_ID       = 1;
const LOGIN_PW       = 2;
const LOGIN_DATA     = 3;
const LOGIN_POST     = 4;

function Handler(main){
  this.main=main;
}
Handler.prototype={
  stage: 0,
  initStage: ST_LOGIN,
  count:-1,
  data:{desc:""},
  user: "",
  password: null,
  loginData:[],
  started:false,
  retry:1,

  reset : function(){
    this.count=-1;
    this.data={};
    this.data.desc=this.getDesc();
    this.stage=(this.checkLogin?ST_CHECK:this.initStage);
  },
  setLoginData:function(){
    if(this.loginData){
      var post=(this.loginData[LOGIN_DATA]?this.loginData[LOGIN_DATA]:"");
      if(this.loginData[LOGIN_ID]){
        if(post)post+="&";
        var user;
        if(this.needServer)user=this.user.split("|")[0];
        else user=this.user;
        post+=this.loginData[LOGIN_ID]+"="+encodeURIComponent(user);
      }
      if(this.loginData[LOGIN_PW]){
        if(post)post+="&";
        post+=this.loginData[LOGIN_PW]+"="+encodeURIComponent(this.password);
      }
      //this.loginData.splice(1,this.loginData.length-1);
      this.loginData[LOGIN_POST]=post;
    }
  },
  check : function(){
    if(!this.enabled)return;
    this.stop();
    if(this.count<0)this.reset();
    else this.stage=ST_DATA;
    this.started=true;
    this.doNext("");
  },
  stop : function(){
    if(this.xhr){
      this.xhr.onreadystatechange=null;
      this.xhr.abort();
      delete this.xhr;
    }
  },
  doNext:function(aData,aHttp){
    try{
      if(!this.process(aData,aHttp))++this.stage;
    }catch(e){
      this.onError();
dout(this.id+" "+this.stage+" "+e);
    }
  },
  process:function(aData,aHttp){
//dout(this.stage);
//dout(this.stage+" "+aData);
    switch(this.stage){
    case ST_LOGIN:
      this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]);
      return false;
    case ST_LOGIN_RES:
      this.stage=ST_DATA;
      return this.process(aData,aHttp);
    case ST_DATA:
      this.getHtml(this.dataURL);
      return false;
    case ST_DATA_RES:
      var n=parseInt(this.getCount(aData));
      this.count=isNaN(n)?-1:n;
      this.data=this.getData(aData);
      this.data.desc=this.getDesc();
      ////////delete later///////////////////
      if(this.data.folders){
        if(typeof this.data.folders[0]=="string"){
          var ar=this.data.folders;
          var ar2=[];
          for(var i=0;i<ar.length;i+=2){
            ar2.push({id:ar[i],count:ar[i+1]});
          }
          this.data.folders=ar2;
        }
      }
      ///////////////////////////////////////
      if(this.count<0){
        if(this.noPwd){
          this.password="";
        }
        if(this.retry<1){
          ++this.retry;
          this.check();
          return true;
        }else{
          this.reset();
        }
      }else{
        this.retry=0;
        this.stage=ST_DATA;
      }
      this.main.setResult(this);
      return true;
    }
    if(this.stage<ST_PRE&&this.checkLogin){
      return this.checkLogin(aData);
    }
    this.onError();
    return true;
  },
  onError : function(){
opera.postError("[onError] "+this.id+" "+this.user+" "+this.stage);
    if(this.noPwd){
      this.password="";
    }
    this.reset();
    this.main.setResult(this);
  },

  getHtml:function(aURL,aPostData,aHeaders,aMethod) {
    if(aURL instanceof Array){
      aPostData=aURL[1];
      aHeaders=aURL[2];
      aMethod=aURL[3];
      aURL=aURL[0];
    }
    this.xhr = new XMLHttpRequest();
    var tmp=this;
    this.xhr.onreadystatechange=function(){
      tmp.onStateChange();
    };
    var setContentType=false;
    if(aPostData||aPostData==""){
      this.xhr.open(aMethod?aMethod:"POST", aURL, true);
      setContentType=true;
    }else this.xhr.open(aMethod?aMethod:"GET", aURL, true);
    if(aHeaders){
      for(var t in aHeaders){
        if(t=="Content-Type")setContentType=false;
        this.xhr.setRequestHeader(t,aHeaders[t]);
      }
    }
    if(setContentType)this.xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    try{
    this.xhr.send(aPostData);
    }catch(e){
      this.process("");
dout("xhr.send "+e);
    }
  },
  onStateChange:function(){
    if(this.xhr.readyState==4){
      this.doNext(this.xhr.responseText,this.xhr);
    }
  },
  getViewURL : function(aFolder){
    return this.viewURL;
  },
  getIconURL : function(){
    try{
      var url=this.viewURL.match(/(((\S+):\/\/([^/]+))(\S*\/)?)([^/]*)/);
      if(url)return url[2]+"/favicon.ico";
    }catch(e){}
    return null;
  },
  getCount : function(aData){
    return -1;
  },
  getData : function(aData){
    return {};
  },
  getDesc : function(){
    var n=this.calcCount();
    return n>0?n:"";
  },
  calcCount : function() {
    var aCount=this.count;
    if(this.main.prefs["resetCounter"]){
      if(aCount>=0){
        var count=this.loadCount();
        if(aCount>=count)aCount-=count;
        else{
          this.saveCount(aCount>0?aCount:0)
          aCount=0;
        }
      }
    }
    return aCount;
  },
  loadCount:function(){
    var count=0;
    if(!this.main.counts)this.main.counts=tobwithu.loadPrefs("counts",{});
    var o1=this.main.counts;
    if(!o1[this.id])o1[this.id]={};
    var o=o1[this.id];
    if(typeof o[this.user]!="undefined")count=o[this.user];
    else{
      o[this.user]=0;
      tobwithu.savePrefs("counts",o1);
    }
    return count;
  },
  saveCount:function(n){
    if(!this.main.counts)this.main.counts=tobwithu.loadPrefs("counts",{});
    var o=this.main.counts;
    if(!o[this.id])o[this.id]={};
    o[this.id][this.user]=n;
    tobwithu.savePrefs("counts",o);
  },
  getForm:function(data,name,action){
    var url=null;
    if(name){
      var reg=new RegExp("<form([^>]+?id\\s*=\\s*[\"\']"+name+"[\"\'][\\S\\s]+?)<\/form>","i");
      var s=data.match(reg);
      if(!s)return "";
      data=s[1];
    }
    if(action){
      var fnd=data.match(/action\s*=\s*[\"\'](\S+?)[\"\']/);
      if(fnd)url=fnd[1];
    }
    var re=/<input[^>]+?name\s*=\s*[\"\'](\S+?)[\"\'][^>]+?value\s*=s*[\"\']([\s\S]*?)[\"\'][\s\S]*?>/ig;
    var o;
    var post="";
    while ((o = re.exec(data)) != null){
      if(o[0].match(/type\s*=\s*[\"\']?hidden[\"\']?/i)){
        if(post)post+="&";
        post+=o[1]+"="+encodeURIComponent(o[2]);
      }
    }
    if(action)return url?[url,post]:null;
    return post;
  },
  checkLogin:function(aData){
    switch(this.stage){
    case ST_CHECK:
      this.stage=this.initStage;
      if(this.logoutURL){//for Old script
        this.getHtml(this.logoutURL);
        return true;
      }else return this.process(aData);
    }
    this.onError();
    return true;
  },
  delay:function(sec){
    var self=this;
    window.setTimeout(function(){self.doNext("");},sec);
  },
  setResult:function(){
    this.main.setResult(this);
  },
  openAuthDialog:function(id,user,url){
    this.main.openAuthDialog(this.ind,id,user,url);
  },
  getScriptList:function(){
    var self=this;    
    window.setTimeout(function(){self.doNext(self.main.getScriptList());},100);
  }
}
Handler.prototype.baseProcess=Handler.prototype.process;
///// delete later 2013-05-07 //////////
Handler.prototype.openCaptchaDialog=Handler.prototype.openAuthDialog;